{----------------------------------------------------------------------------}
{                                                                            }
{                             GBASE Version 3.2                              }
{                   Copyright (C) 1994-95 By The GodFather                   }
{                                                                            }
{----------------------------------------------------------------------------}
{                       Last corection - 1 August 1995                       }
{----------------------------------------------------------------------------}

{$M, 16380, 0, 655360}

USES
  Dos, Crt, Objects, Screen, Keybord, Strn,
  Windows, List, Buttons, Menus, TextFont;

CONST
  Version        = 'Version 3.2';
  Info           = ' Information ';
  DataName       = 'GF.GBD';
  GamesFileName  = 'CATALOG.GB!';
  SelectFileName = 'SELECTED.GB!';

  GBaseHeader    = 'GBASE v3.2'+#10;

  evDialogBack   = 9;     cDialogBack   = 7;
  evButtonBack   = 144;   cButtonBack   = 112;
  evButtonFace   = 112;   cButtonFace   = 32;
  evButtonSelect = 241;   cButtonSelect = 47;

  MenuAttrib     = 71;
  MenuSAttrib    = 79;
  BackAttrib     = 23;
  BackSAttrib    = 31;

  Cga            = $01;
  Ega            = $02;
  Vga            = $04;
  SoundBlaster   = $08;
  Cracked        = $10;
  Selected       = $20;

  Key1           = $D5;
  Key2           = $4A;

  MaxLength      = 37;

TYPE
  TSortMetod= (sName,sType,sFile,sSize);
  TDataInfo = RECORD
      GName : ARRAY[1..MaxLength] OF Char;
      GType : ARRAY[1..MaxLength] OF Char;
      GFNam : ARRAY[1..13] OF Char;
      GFlags: Byte;
      GSize : LongInt;
  END;
  PGameInfo = ^TGameInfo;
  TGameInfo = OBJECT( TObject )
     Name   : PString;
     Tipe   : PString;
     FName  : PString;
     Flags  : Byte;
     Size   : LongInt;
     CONSTRUCTOR Init(aName,aType,aFName:STRING; aFlags:Byte; aSize:LongInt);
     DESTRUCTOR Done; VIRTUAL;
  END;
  PGameCollection = ^TGameCollection;
  TGameCollection = OBJECT( TSortedCollection )
    Comment  : STRING[40];
    SortMetod: TSortMetod;
    Ascending: Boolean;
    FUNCTION KeyOf( Item: Pointer ) : Pointer; VIRTUAL;
    FUNCTION Compare( Key1, Key2: Pointer ) : Integer; VIRTUAL;
  END;

  THeader    = RECORD
    Header   : STRING[10];
    TempCr   : Char;
    Comment  : STRING[40];
    SortMetod: TSortMetod;
    Ascending: Boolean;
  END;

VAR
  ListSettings: PListSettings;
  FileHeader: STRING;
  DFileName: STRING;
  Database: PGameCollection;
  GameInfo: PGameInfo;
  AnEntry: PGameInfo;

  TabPos,
  DialogBack,
  ButtonBack,
  ButtonShadow,
  ButtonFace,
  ButtonSelect: Byte;

  I,
  MaxSelect,
  GamesCrack,
  SelectCrack: Word;

  VLine,
  RAngle: Char;

  GamesSize,
  SelectSize,
  DiskFreeSize: LongInt;

  Changed,
  Finished,
  CyrilicKB,
  ATabOrder: Boolean;

  Buffer: Pointer;
  OldX  : Byte;
  OldY  : Byte;

{--------------------------------------}
{ Collection initialization procedures }
{--------------------------------------}
CONSTRUCTOR TGameInfo.Init
              (aName,aType,aFName: STRING; aFlags:Byte; aSize: LongInt);
BEGIN
  Name    := NewStr(aName);
  Tipe    := NewStr(aType);
  FName   := NewStr(aFName);
  Flags   := aFlags;
  Size    := aSize;
END; { Init }

DESTRUCTOR TGameInfo.Done;
BEGIN
  DisposeStr(Name);
  DisposeStr(Tipe);
  DisposeStr(FName);
END;

FUNCTION TGameCollection.KeyOf( Item: Pointer ) : Pointer;
BEGIN
  CASE SortMetod OF
    sName: KeyOf := @PGameInfo( Item )^.Name;
    sType: KeyOf := @PGameInfo( Item )^.Tipe;
    sFile: KeyOf := @PGameInfo( Item )^.FName;
    sSize: KeyOf := @PGameInfo( Item )^.Size;
  END;
END; { KeyOf }

FUNCTION TGameCollection.Compare( Key1, Key2: Pointer ) : Integer;
VAR F,N: Integer;
BEGIN
  IF Ascending
    THEN BEGIN F := -1; N := 1; END
    ELSE BEGIN F := 1; N := -1; END;
  IF SortMetod IN [sName,sType,sFile]
   THEN IF PString(Key1^)^ = PString(Key2^)^
         THEN Compare := 0
         ELSE IF PString(Key1^)^ < PString(Key2^)^
               THEN Compare := F
               ELSE Compare := N
   ELSE IF LongInt( Key1^ ) = LongInt( Key2^ )
         THEN Compare := 0
         ELSE IF LongInt( Key1^ ) < LongInt( Key2^ )
               THEN Compare := F
               ELSE Compare := N;
END; { Compare }
{------------------------------------------------}

{-----------------}
{ Misc procedures }
{-----------------}
PROCEDURE SaveScreen;
BEGIN
  OldX := WhereX;
  OldY := WhereY;
  GetMem( Buffer, 4000 );
  PartSave( 1, 1, 80, 25, Buffer^ );
END; { SaveScreen }

PROCEDURE RestoreScreen;
BEGIN
  PartRestore( 1, 1, 80, 25, Buffer^ );
  GotoXY( OldX, OldY );
  FreeMem( Buffer, 4000 );
END; { Restore Screen }

PROCEDURE WriteExt( S : STRING; Color: Byte; S1: STRING; Color1: Byte );
VAR I:Byte; C:Boolean;
BEGIN
  TextColor( Color ); Write( S  );
  TextColor( Color1); C := False;
  FOR I := 1 TO Length(S1) DO
  BEGIN
    IF S1[I] = '"' THEN
    BEGIN
      C := NOT C;
      S1[I] := ' ';
      IF C THEN TextColor(15) ELSE TextColor(Color1);
    END;
    Write(S1[I]);
  END;
END; { WriteExt }

PROCEDURE Error( Arg: STRING );
BEGIN
  Dispose( Database, Done );
  RmWin;
  Writeln;
  Writeln( Arg );
  Halt( 1 );
END; { Error }

PROCEDURE UpdateChange( Chng: Boolean );
VAR TmCh: Char;
BEGIN
  Changed := Chng;
  IF Changed THEN TmCh := '*' ELSE TmCh := ' ';
  FastWrite(78, 1, Attr(4, 7), TmCh);
END;

PROCEDURE UpdateCyrilic( Beep: Boolean );
VAR TStr: STRING;
BEGIN
  CyrilicKB := NOT CyrilicKB;
  IF CyrilicKB THEN TStr := 'Cyrilic' ELSE TStr := '       ';
  FastWrite(69, 1, Attr(4, 7), TStr);
  IF Beep THEN
  BEGIN
    Sound(1000); Delay(25); NoSound;
    Sound(2000); Delay(50); NoSound;
    REPEAT UNTIL NOT LeftShiftPressed;
  END;
END;

{$F+}
PROCEDURE CyrilicHook;
BEGIN
  IF AltPressed AND LeftShiftPressed THEN UpdateCyrilic( True );
END;
{$F-}
{------------------------------------------------}

{---------------------}
{ Information windows }
{---------------------}
PROCEDURE About;
BEGIN
  MkWin(10, 5, 61, 15, White, Cyan, True, cyrDouble, ' About ');
  TextAttr := 48;
  Writeln;
  WriteCStr(60, True, 'GBASE '+Version);
  WriteCStr(60, True, 'Copyright (C) 1994-95 by The GodFather');
  Writeln; TextColor(14);
  WriteCStr(60, True, 'If you wish a simular program but adapted for your');
  WriteCStr(59, True, 'needs, just find me and I will make it for you.');
  WriteCStr(60, True, 'Of course we`ll make a deal.');
  Writeln; TextColor(0);
  WriteCStr(61, True, 'You can contact me here:');
  Writeln; TextColor( 15 );
  WriteCStr(62, True, 'EMAIL: gf@top.bg');
  WriteCStr(60, True, 'EMAIL: gf@cybcom.net');
  WriteCStr(60, True, 'URL: http://georgi.top.bg/');
  Pause;
  RmWin;
END; { AboutProgram }

PROCEDURE Help;
BEGIN
  MkWin(21,5,40,14,White,Cyan,True,cyrDouble,' Help ');
  Writeln;
  WriteExt('   F1', 14, '    "Help"'#13#10, 0);
  WriteExt('   F2', 14, '    "Save"datafile'#13#10,0);
  WriteExt('   F4', 14, '    "Write all"to textfile'#13#10,0);
  WriteExt('   F5', 14, '    "Write selected"to textfile'#13#10,0);
  Writeln;
  WriteExt('   Ins', 14, '   "Add"game'#13#10,0);
  WriteExt('   Tab', 14, '   "Edit"game'#13#10,0);
  WriteExt('   Del', 14, '   "Delete"game'#13#10,0);
  WriteExt('   Ctrl+D', 14, '"Delete selected"games'#13#10,0);
  Writeln;
  WriteExt('   Alt+X', 14, ' "Exit"from"GBASE"',0);
  Pause;
  RmWin;
END; { GeneralHelp }

PROCEDURE ShowStatus;
BEGIN
  MkWin( 7, 6, 67, 13, White, Cyan, True, cyrDouble, Info);
  Writeln;
  WriteExt('  Current data file: ',0,DFileName+#13#10,14);
  WriteExt('  Title of the file: ',0,Database^.Comment+#13#10,14);
  WriteExt('  Free memory      : ',0,Convert(MemAvail)+
           ' bytes (about '+Convert(MemAvail DIV 90)+' games)'#13#10,14);
  WriteExt('  Disk free size   : ',0,Convert(DiskFreeSize)+' bytes'#13#10,14);
  TextColor(0);
  Writeln;
  Writeln('                  All            Selected       NOT Selected');
  Writeln;
  Writeln('  Games');
  Writeln('  Cracked');
  Writeln('  Size');
  MkWin(19, 14, 17, 4, Black, Cyan, False, cyrSingle, '');
  TextColor(14);
  Writeln(' ',Convert(ListSettings^.MaxTopics));
  Writeln(' ',Convert(GamesCrack));
  Write(' ',Convert(GamesSize));
  MkWin(36, 14, 17, 4, Black, Cyan, False, cyrSingle, '');
  TextColor(14);
  Writeln(' ',Convert(MaxSelect));
  Writeln(' ',Convert(SelectCrack));
  Write(' ',Convert(SelectSize));
  MkWin(53, 14, 17, 4, Black, Cyan, False, cyrSingle, '');
  TextColor(14);
  Writeln(' ',Convert(ListSettings^.MaxTopics-MaxSelect));
  Writeln(' ',Convert(GamesCrack-SelectCrack));
  Write(' ',Convert(GamesSize-SelectSize));
  WriteAT(36,14,Black,Cyan,'');
  WriteAT(36,18,Black,Cyan,'');
  WriteAT(53,14,Black,Cyan,'');
  WriteAT(53,18,Black,Cyan,'');
  Pause;
  RmWin;  RmWin;
  RmWin;  RmWin;
END; { ShowStatus }

PROCEDURE TheEnd;
BEGIN
  Dispose(Database, Done);
  Load8x16;
  RestoreScreen;
  Cursor( On );
  TextAttr := 14;
  Writeln;
  WriteCStr(80, False, 'Thank you for using GBASE by The GodFather');
  TextAttr := 7; Writeln(' ');
  Halt( 0 );
END; { TheEnd }
{------------------------------------------------}

{-------------------------------------}
{ Dialog boxes and boxes for massages }
{-------------------------------------}
PROCEDURE WaitBox;
BEGIN
  MkWin(22, 8, 40, 4, White, Red, True, cyrDouble, Info );
  Writeln;
  WriteCStr(40, False, 'Please wait . . . ' );
END; { Wait Box }

PROCEDURE InfoBox( Arg: STRING; Alert: Boolean );
VAR
  OK: PBCollection;
  DBack: Byte;
  BBack: Byte;
BEGIN
  IF Alert THEN
  BEGIN
    DBack := 4;
    BBack := 64;
  END ELSE
  BEGIN
    DBack := DialogBack;
    BBack := ButtonBack;
  END;
  OK := New( PBCollection, Init( 1, 1 ) );
  OK^.Insert( New( PButton, Init('    OK    ', ' ', 21, 6, ButtonFace, BBack, 0, ButtonSelect )));
  MkWin( 15, 7, 52, 8, White, DBack, True, cyrDouble, Info );
  Writeln(#13#10);
  Dec( TextAttr );
  WriteCStr( 52, False, Arg );
  OK^.Choose( 0 );
  Dispose( OK, Done );
  RmWin;
END; { InfoBox }

FUNCTION PromptBox( Arg: STRING; Alert: Boolean ) : Boolean;
VAR YN: PBCollection;
  DBack: Byte;
  BBack: Byte;
BEGIN
  IF Alert THEN
  BEGIN
    DBack := 4;
    BBack := 64;
  END ELSE
  BEGIN
    DBack := DialogBack;
    BBack := ButtonBack;
  END;
  YN := New( PBCollection, Init( 2, 1 ) );
  YN^.Insert( New( PButton, Init('    OK    ', ' ', 10, 6, ButtonFace, BBack, 0, ButtonSelect )));
  YN^.Insert( New( PButton, Init('  Cancel  ', ' ', 32, 6, ButtonFace, BBack, 0, ButtonSelect )));
  PromptBox := False;
  MkWin(15, 7, 52, 8, White, DBack, True, cyrDouble, Info );
  Writeln(#13#10);
  WriteCStr( 52, False, Arg );
  YN^.Choose( 0 );
  IF NOT YN^.EscPressed AND (YN^.ButtonNumb = 0) THEN PromptBox := True;
  Dispose( YN, Done );
  RmWin;
END; { PromptBox }
{------------------------------------------------}

{----------------------------------}
{ Read Database from database file }
{----------------------------------}
PROCEDURE ReadDataFile;
VAR
  Name,
  Tipe,
  FName: STRING;
  Flags: Byte;
  Size : LongInt;
  DFile: FILE;
  Zero : Boolean;
  OLen : Boolean;
  R    : Word;
  TheData: TDataInfo;

BEGIN
  DFileName := DataName;
  Assign(DFile, DFileName);
  {$I-}
    Reset(DFile, 1);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    DFileName := FSearch( DFileName, GetEnv('PATH') );
    Assign(DFile, DFileName);
    {$I-}
     Reset(DFile, 1);
    {$I+}
    IF (IOResult <> 0) OR (DFileName = '') THEN Error('Can''t find '+DataName);
  END;
  FOR I:=1 TO FileSize(DFile) DIV SizeOf(TheData) DO
  BEGIN
    IF MemAvail < 1000 THEN
    BEGIN
      Dispose(Database, Done);
      Error('Insufficient memory. Contact with The GodFather');
    END;
    BlockRead(DFile, TheData, SizeOf( TheData ), R );
    IF IOResult <> 0 THEN Error('Read Error');
    Seek(DFile, I*SizeOf(TheData));
    IF IOResult <> 0 THEN Error('Seek Error');
    WITH TheData DO
    BEGIN
      OLen := False;
      FOR R := 1 TO MaxLength DO
      BEGIN
        Name[R] := Chr( Ord( GName[R] ) XOR Key1 XOR Key2 );
        IF Name[R] = #0 THEN
        BEGIN
          IF NOT OLen THEN Name[0] := Chr( R - 1 );
          OLen := True;
          Zero := True
        END ELSE Zero := False;
        IF Zero THEN Name[R] := #0;
      END;
      OLen := False;
      FOR R := 1 TO MaxLength DO
      BEGIN
        Tipe[R] := Chr( Ord( GType[R] ) XOR Key1 XOR Key2 );
        IF Tipe[R] = #0 THEN
        BEGIN
          IF NOT OLen THEN Tipe[0] := Chr( R - 1 );
          OLen := True;
          Zero := True
        END ELSE Zero := False;
        IF Zero THEN Tipe[R] := #0;
      END;
      OLen := False;
      FOR R := 1 TO 13 DO
      BEGIN
        FName[R] := Chr( Ord( GFNam[R] ) XOR Key1 XOR Key2 );
        IF FName[R] = #0 THEN
        BEGIN
          IF NOT OLen THEN FName[0] := Chr( R - 1 );
          OLen := True;
          Zero := True
        END ELSE Zero := False;
        IF Zero THEN FName[R] := #0;
      END;
      Size  := GSize XOR Key1 XOR Key2;
      Flags := GFlags XOR Key1 XOR Key2;
      IF (Flags AND Cracked) <> 0 THEN Inc( GamesCrack );
      IF (Flags AND Selected)<> 0 THEN
      BEGIN
        Inc(MaxSelect);
        Inc(SelectSize, Size);
      END;
      Inc(GamesSize, Size);
      Database^.Insert( New( PGameInfo,
                 Init( Name, Tipe, FName, Flags, Size )));
    END;
  END;
  Close(DFile);
END; { ReadDataFile }
{------------------------------------------------}

{---------------------------------}
{ Write Database to database file }
{---------------------------------}
PROCEDURE WriteDataFile( MassageBox: Boolean );
VAR
  DFile: FILE;
  TheData: TDataInfo;

  PROCEDURE WriteEntry( OneEntry: PGameInfo ); FAR;
  VAR Written, R: Word;
  BEGIN
    WITH TheData DO
    WITH OneEntry^ DO
    BEGIN
      FOR R := 1 TO MaxLength DO
      BEGIN
        IF R <= Length( Name^ )
          THEN GName[R] := Name^[R]
          ELSE GName[R] := Chr( Random( 255 ) );
        GName[R] := Chr( Ord( GName[R] ) XOR Key1 XOR Key2 );
        IF R <= Length( Tipe^ )
          THEN GType[R] := Tipe^[R]
          ELSE GType[R] := Chr( Random( 255 ) );
        GType[R] := Chr( Ord( GType[R] ) XOR Key1 XOR Key2 );
      END;
      FOR R := 1 TO 13 DO
      BEGIN
        IF R <= Length( FName^ )
          THEN GFNam[R] := FName^[R]
          ELSE GFNam[R] := Chr( Random( 255 ) );
        GFNam[R] := Chr( Ord( GFNam[R] ) XOR Key1 XOR Key2 );
      END;
      GName[Length(Name^)+1] := #159;
      GType[Length(Tipe^)+1] := #159;
      GFNam[Length(FName^)+1]:= #159;
      GFlags := Flags XOR Key1 XOR Key2;
      GSize  := Size  XOR Key1 XOR Key2;
    END;
    BlockWrite(DFile, TheData, SizeOf( TheData ), Written);
  END;

BEGIN
  IF DiskFreeSize < ListSettings^.MaxTopics * SizeOf( TheData )
  THEN InfoBox('Not enough free space on disk', True)
  ELSE
  BEGIN
    WaitBox;
    Assign(DFile, DFileName);
    Rewrite(DFile, 1);
    Database^.ForEach( @WriteEntry );
    Close(DFile);
    Reset(DFile);
    SetFTime(DFile,0);
    Close(DFile);
    RmWin;
    IF MassageBox THEN InfoBox('Database file is saved',False);
    UpdateChange( False );
  END;
END; { WriteDataFile }
{------------------------------------------------}

{-----------------------------}
{ Print Database to text file }
{-----------------------------}
PROCEDURE WriteTextFile( OnlySelected: Boolean );
VAR
  F   : Text;
  Buf : Pointer;
  FName: STRING;
  Temp: STRING;
  SFlag,
  CFlag,
  EFlag,
  VFlag: Word;
  MGames,
  GCrack: Word;
  GSize: LongInt;

  PROCEDURE PrintEntry( OneEntry: PGameInfo ); FAR;
  VAR R: Byte; Tmp: Byte;
  BEGIN
    WITH OneEntry^ DO
    BEGIN
      Tmp := Flags;
      IF NOT OnlySelected THEN Flags := Flags OR Selected;
      IF (Flags AND Selected) <> 0 THEN
      BEGIN
        Write(F, VLine,' ',Convert( Size ):10,' ',VLine);
        IF (Flags AND Cga) <> 0 THEN Write(F, 'C') ELSE Write(F, '-');
        IF (Flags AND Ega) <> 0 THEN Write(F, 'E') ELSE Write(F, '-');
        IF (Flags AND Vga) <> 0 THEN Write(F, 'V') ELSE Write(F, '-');
        IF (Flags AND SoundBlaster) <> 0 THEN Write(F, VLine,'SB',VLine) ELSE Write(F, VLine,'  ',VLine);
        IF (Flags AND Cracked) <> 0 THEN Write(F, '',VLine) ELSE Write(F, ' ',VLine);
        IF (Flags AND Cga) <> 0 THEN Inc( CFlag );
        IF (Flags AND Ega) <> 0 THEN Inc( EFlag );
        IF (Flags AND Vga) <> 0 THEN Inc( VFlag );
        IF (Flags AND SoundBlaster) <> 0 THEN Inc( SFlag );
        Write(F, ' ' ,Name^); FOR R := Length(Name^) TO 36 DO Write(F, #32);
        Write(F, VLine,' ',Tipe^); FOR R := Length(Tipe^) TO 36 DO Write(F, #32);
        Write(F, VLine,' ',FName^); FOR R := Length(FName^) TO 11 DO Write(F, #32);
        Writeln(F,' ',VLine);
      END;
      IF NOT OnlySelected THEN Flags := Tmp;
    END;
  END;

BEGIN
  CFlag := 0;  EFlag := 0;
  VFlag := 0;  SFlag := 0;
  IF OnlySelected THEN
  BEGIN
    MGames := MaxSelect;
    GCrack := SelectCrack;
    GSize  := SelectSize;
    FName  := SelectFileName;
  END ELSE
  BEGIN
    MGames := ListSettings^.MaxTopics;
    GCrack := GamesCrack;
    GSize  := GamesSize;
    FName  := GamesFileName;
  END;
  IF DiskFreeSize < (MGames  * 110) + 1000
  THEN InfoBox('Not enough free space on disk',True)
  ELSE
  BEGIN
    Assign(F,FName);
    {$I-}
      Rewrite(F);
    {$I+}
    IF IOResult <> 0 THEN
    BEGIN
      InfoBox('Error creating '+FName,True);
      Exit;
    END;
    WaitBox;
    GetMem(Buf,32767);
    SetTextBuf(F,Buf^,32767);
    Writeln(F);
    Writeln(F,PadCenter('This catalog is created with GBASE '+Version,120,' '),#13#10);
    Writeln(F,'     Size     Vid Sn Cr Name',Replicate(35,' '),'Type',Replicate(35,' '),'File');
    Writeln(F,'',Replicate(38,''),'',Replicate(38,''),'',''+RAngle);
    Database^.ForEach( @PrintEntry );
    Writeln(F,'',Replicate(38,''),'',Replicate(38,''),'',''#13#10);
    Writeln(F,'      Games in catalog ................... ', MGames);
    Writeln(F,'      Games which support CGA ............ ', CFlag );
    Writeln(F,'      Games which support EGA ............ ', EFlag );
    Writeln(F,'      Games which support VGA ............ ', VFlag );
    Writeln(F,'      Games which support SOUND BLASTER .. ', SFlag );
    Writeln(F,'      Cracked Games ...................... ', GCrack );
    Writeln(F,'      Games size ......................... ', Convert( GSize ),' bytes'#13#10);
    Close(F);
    FreeMem(Buf,32767);
{    Reset(F);
    SetFTime(F,0);
    Close(F);}
    RmWin;
    InfoBox(FName+' is created',False);
  END;
END; { WriteTextFile }

PROCEDURE WriteDescriptionFile;
VAR
  F: Text;
  Buf: Pointer;
  FileTime: Longint;

  PROCEDURE PrintEntry( OneEntry: PGameInfo ); FAR;
  VAR R: Byte; Tmp: Byte;
  BEGIN
    WITH OneEntry^ DO
    BEGIN
      Write(F,FName^);
      Write(F,' ',VLine);
      IF (Flags AND Cga) <> 0 THEN Write(F, 'C') ELSE Write(F, '');
      IF (Flags AND Ega) <> 0 THEN Write(F, 'E') ELSE Write(F, '');
      IF (Flags AND Vga) <> 0 THEN Write(F, 'V') ELSE Write(F, '');
      IF (Flags AND SoundBlaster) <> 0 THEN Write(F, VLine,'SB',VLine) ELSE Write(F, VLine,'',VLine);
      IF (Flags AND Cracked) <> 0 THEN Write(F, '',VLine) ELSE Write(F, '',VLine);
      Writeln(F, ' ' ,Name^);
    END;
  END;

BEGIN
  IF DiskFreeSize < (Database^.Count * 50) THEN
  BEGIN
    InfoBox('Not enough free space on disk',True);
    Exit;
  END;
  Assign(F,'DESCRIPT.ION');
  {$I-}
    Rewrite(F);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    InfoBox('Error creating DESCRIPT.ION',True);
    Exit;
  END;
  WaitBox;
  GetMem(Buf,32767);
  SetTextBuf(F,Buf^,32767);
  Database^.ForEach( @PrintEntry );
  Writeln(F,'DESCRIPT.ION 4DOS Description File');
  SetFTime(F,0);
  Close(F);
  FreeMem(Buf,32767);
  Reset(F);
  SetFTime(F,0);
  Close(F);
  RmWin;
  InfoBox('DESCRIPT.ION is created',False);
END; { WriteDescriptionFile }

PROCEDURE AlternateExit;
VAR YN: PBCollection; Ch: Byte; Ep: Boolean;
BEGIN
  YN := New(PBCollection,Init(3,1));
  YN^.Insert(New(PButton,Init('    OK    ',' ',5, 6,ButtonFace,ButtonBack,0,ButtonSelect)));
  YN^.Insert(New(PButton,Init('    No    ',' ',20,6,ButtonFace,ButtonBack,0,ButtonSelect)));
  YN^.Insert(New(PButton,Init('  Cancel  ',' ',35,6,ButtonFace,ButtonBack,0,ButtonSelect)));
  MkWin(16,7,52,8,White,DialogBack,True,cyrDouble,Info);
  Writeln(#13#10);
  WriteCStr( 52, False, 'Database has been modified. SAVE ?' );
  YN^.Choose( 1 );
  Ch := YN^.ButtonNumb;
  Ep := YN^.EscPressed;
  Dispose( YN, Done );
  RmWin;
  IF NOT Ep THEN
  BEGIN
    IF Ch = 0 THEN BEGIN WriteDataFile( False ); RmWin; END;
    IF (Ch=0) OR (Ch=1) THEN ListSettings^.EndOfList := True;
  END;
END { AlternateExit };
{------------------------------------------------}

{------------------}
{ Edit game record }
{------------------}
 PROCEDURE WriteCBox( B: Boolean );
 BEGIN
   TextAttr := Attr(White, DialogBack);  Write('   ');
   TextAttr := 7;
   IF B THEN Write('  [x]') ELSE Write('  [ ]');
 END;

 PROCEDURE UpdateCBox( XPos, YPos: Byte; Masc: Byte );
 BEGIN
   WITH GameInfo^ DO
   BEGIN
     IF (Flags AND Masc) <> 0
       THEN Flags := Flags AND NOT Masc
       ELSE Flags := Flags OR Masc;
     TextAttr := 7;
     GotoXY( XPos, YPos );
     IF (Flags AND Masc) <> 0 THEN Write('x') ELSE Write(' ');
   END;
 END;

 PROCEDURE WriteHL( S: STRING; Back: Byte; Num: Boolean );
 VAR I: Byte;
 BEGIN
   FOR I := 1 TO Length( S ) DO
     IF S[I] = '~'
       THEN
         BEGIN
           TextAttr := Attr( 14, Back ); Inc( I );
           Write( S[I] );
           IF Num
             THEN Dec( TextAttr, 7 )
             ELSE Inc( TextAttr, 1 );
         END
       ELSE Write( S[I] );
 END;

 PROCEDURE WriteField( S: STRING; FLength, XPos, YPos: Byte; Push : Boolean );
 VAR I, X, Y, OldAttr: Byte;
 BEGIN
   X := WhereX; Y := WhereY;
   GotoXY( XPos-1, YPos );
   OldAttr  := TextAttr;
   TextAttr := 7; Write(' ',S);
   FOR I := Length( S ) TO FLength - 1 DO Write(''); Write(' ');
   TextAttr := OldAttr;
   IF Push THEN GotoXY( X, Y );
 END;

 PROCEDURE EditField( VAR S: STRING;
                      FieldLength,
                      XPos, YPos: Byte;
                      Number,
                      UpperOnly: Boolean );
 VAR
   Key: Word;
   Tst: Char;
   TmpLG: LongInt;
   Code : Integer;
   TempS: STRING;
   TmpCP: Byte;
   EndOfEditing: Boolean;

 PROCEDURE SetCheckBoxes;
 VAR X,Y: Byte;
 BEGIN
  X:=WhereX;  Y:=WhereY;
  CASE Key OF
    kbAltC: UpdateCBox( 7,  8, Cga );
    kbAltE: UpdateCBox( 7,  9, Ega );
    kbAltV: UpdateCBox( 7, 10, Vga );
    kbAltB: UpdateCBox( 31, 8, SoundBlaster );
    kbAltR: UpdateCBox( 31, 9, Cracked );
  END;
  GotoXY(X,Y);
 END;

 FUNCTION ExitTest: Boolean;

   PROCEDURE FastUpdate;
   BEGIN
     TempS := S;
     TmpCP := Length( TempS ) + 1;
     EndOfEditing := True;
     GotoXY( XPos + TmpCP - 1, YPos );
     WriteField( TempS, FieldLength, XPos, YPos, True );
   END;

   PROCEDURE SetValues;
   BEGIN
     S := TempS;
     EndOfEditing := True
   END;

 BEGIN
   ExitTest := True;
   IF Number
     THEN BEGIN
            Val(TempS,TmpLG,Code);
            IF Code <> 0
              THEN FastUpdate
              ELSE SetValues;
          END
     ELSE BEGIN
            IF TempS = ''
              THEN FastUpdate
              ELSE SetValues;
          END
 END;

 PROCEDURE SetTP(V: Byte);
 BEGIN
   TabPos := V;
   ExitTest;
 END;

 BEGIN
   Cursor( On );
   IF (S = 'New game') OR
      (S = 'No type defined') OR
      (S = 'UNKNOWN') OR
      (S = '0') THEN TempS := ''
                ELSE TempS := S;
   TmpCP := Length( TempS ) + 1;
   EndOfEditing := False;
   GotoXY( XPos + TmpCP - 1, YPos );
   WriteField( TempS, FieldLength, XPos, YPos, True );
   REPEAT
     Key := GetKey;
     CASE Key OF
       kbLeft: IF TmpCP > 1 THEN
               BEGIN
                 GotoXY( WhereX - 1, WhereY );
                 Dec( TmpCP );
               END;
      kbRight: IF TmpCP < FieldLength THEN
               BEGIN
                 GotoXY( WhereX + 1, WhereY );
                 Inc( TmpCP );
               END;
       kbHome: BEGIN
                 TmpCP := 1;
                 GotoXY( XPos, YPos );
               END;
        kbEnd: BEGIN
                 TmpCP := Length( TempS ) + 1;
                 GotoXY( XPos + TmpCP - 1, YPos );
               END;
     kbBSpace: IF TmpCP > 1 THEN
               BEGIN
                 GotoXY( WhereX - 1, WhereY );
                 Dec( TmpCP );
                 Delete( TempS, TmpCP, 1 );
                 WriteField( TempS, FieldLength, XPos, YPos, True );
               END;
        kbDel: BEGIN
                 Delete( TempS, TmpCP, 1 );
                 WriteField( TempS, FieldLength, XPos, YPos, True );
               END;
       kbAltD: BEGIN
                 TmpCp := 1; GotoXY( XPos, YPos );
                 TempS := '';
                 WriteField( TempS, FieldLength, XPos, YPos, True );
               END;
     kbSpace..126:
               IF (Length( TempS ) < FieldLength) AND
                  (TmpCP < Length( TempS ) + 2)
               THEN
               BEGIN
                 IF (TmpCP=1) AND (Key IN [97..122]) THEN Dec(Key,32);
                 IF (UpperOnly) AND (Key IN [97..122]) THEN Dec(Key,32);
                 IF (TempS[TmpCP - 1] = ' ')
                    AND NOT CyrilicKB
                    AND NOT ShiftPressed
                    AND (Key IN [97..122]) THEN Dec(Key,32);
                 IF CyrilicKB
                   THEN Insert(Translate(Lat,Cyr,Chr(Key)),TempS,TmpCP)
                   ELSE Insert(Chr(Key),TempS,TmpCP);
                 Inc( TmpCP );
                 GotoXY( WhereX + 1, WhereY );
                 WriteField( TempS, FieldLength, XPos, YPos, True );
               END;
      kbEnter: IF ExitTest THEN Finished := True;
        kbEsc: BEGIN
                 TempS := S;
                 Finished := True;
                 EndOfEditing := True;
                 WriteField( TempS, FieldLength, XPos, YPos, True );
               END;
        kbTab,
       kbSTab: BEGIN
                 IF ExitTest
                   THEN IF Key=kbTab
                          THEN IF TabPos=4 THEN Finished:=True ELSE Inc(TabPos)
                          ELSE IF TabPos=1 THEN Finished:=True ELSE Dec(TabPos);
               END;
       kbAltC,kbAltE,
       kbAltV,kbAltB,
       kbAltR: SetCheckBoxes;
       kbAltN: SetTP(1);
       kbAltT: SetTP(2);
       kbAltS: SetTP(3);
       kbAltF: SetTP(4);
     END; { Case }
   UNTIL EndOfEditing;
   Cursor( Off );
 END;

 {-----------------------------------------}
 {        Hook for DialogBox Buttons       }
 {-----------------------------------------}
 PROCEDURE HookKeybord(VAR Key: Word); FAR;
 VAR SizeStr: STRING; Field: Boolean;
     ErrPos : Integer;
     tmName : STRING[37];
     tmTipe : STRING[37];
     tmSize : LongInt;
     tmFile : STRING[12];

   PROCEDURE SetTP(V:Byte);
   BEGIN
     Field := True;
     TabPos:= V;
   END;

 BEGIN
   PressedHook := NIL;
   Finished    := False;
   Field       := False;
   WITH GameInfo^ DO
   BEGIN
     tmName := Name^;
     tmTipe := Tipe^;
     tmFile := FName^;
     tmSize := Size;
     DisposeStr( Name );
     DisposeStr( Tipe );
     DisposeStr( FName);
   END;
   CASE Key OF
     kbAltC,67,99 : UpdateCBox(7,  8, Cga);
     kbAltE,69,101: UpdateCBox(7,  9, Ega);
     kbAltV,86,118: UpdateCBox(7, 10, Vga);
     kbAltB,66,98 : UpdateCBox(31, 8, SoundBlaster);
     kbAltR,82,114: UpdateCBox(31, 9, Cracked);
     kbAltN,78,110: SetTP(1);
     kbAltT,84,116: SetTP(2);
     kbAltS,83,115: SetTP(3);
     kbAltF,70,102: SetTP(4);
             kbTab: SetTP(1);
            kbSTab: SetTP(4);
   END;
   IF Field THEN
     WITH GameInfo^ DO
       REPEAT
         CASE TabPos OF
           1: EditField( tmName, 36, 10, 2, False, False );
           2: EditField( tmTipe, 36, 10, 4, False, False );
           3: BEGIN
                Str( tmSize, SizeStr );
                EditField( SizeStr, 08, 10, 6, True, False );
                Val( SizeStr, tmSize, ErrPos );
              END;
           4: EditField( tmFile,  12, 34, 6, False, True );
         END;
       UNTIL Finished;
   PressedHook := @HookKeybord;
   WITH GameInfo^ DO
   BEGIN
     Name := NewStr( tmName );
     Tipe := NewStr( tmTipe );
     FName:= NewStr( tmFile );
     Size := tmSize;
   END;
 END;
 {------------------------------------------}

FUNCTION DialogBox( Title: STRING ) : Boolean;
VAR TS: STRING; YN: PBCollection;
BEGIN
  MkWin(16, 5, 50, 15, White, DialogBack, True, cyrDouble, Title);
  WITH GameInfo^ DO
  BEGIN
    Str( Size, TS );
    Writeln;
    WriteHL('   ~Name ', DialogBack, False); WriteField( Name^, 36,10,2,False ); GotoXY(1, 4);
    WriteHL('   ~Type ', DialogBack, False); WriteField( Tipe^, 36,10,4,False ); GotoXY(1, 6);
    WriteHL('   ~Size ', DialogBack, False); WriteField( TS,    08,10,6,False ); GotoXY(25,6);
    WriteHL('   ~File ', DialogBack, False); WriteField( FName^,12,34,6,False );
    Writeln(#13#10);
    Dec( TextAttr, 16 );
    WriteCBox( (Flags AND Cga) <> 0 ); WriteHL('  Support ~CGA  '#13#10,0,True);
    WriteCBox( (Flags AND Ega) <> 0 ); WriteHL('  Support ~EGA  '#13#10,0,True);
    WriteCBox( (Flags AND Vga) <> 0 ); WriteHL('  Support ~VGA  '#13#10,0,True);
    GotoXY( 25, 8 ); WriteCBox( (Flags AND SoundBlaster) <> 0); WriteHL('  Support S~B  ',0,True);
    GotoXY( 25, 9 ); WriteCBox( (Flags AND Cracked) <> 0);  WriteHL('  C~racked     ',0,True);
  END;
  YN := New( PBCollection, Init( 2, 1 ) );
  YN^.Insert( New( PButton, Init('    OK    ', ' ', 11, 13, ButtonFace, ButtonBack, 0, ButtonSelect )));
  YN^.Insert( New( PButton, Init('  Cancel  ', ' ', 30, 13, ButtonFace, ButtonBack, 0, ButtonSelect )));
  PressedHook := @HookKeybord;
  YN^.Choose( 0 );
  PressedHook := NIL;
  IF NOT YN^.EscPressed AND (YN^.ButtonNumb = 0)
    THEN DialogBox := True
    ELSE DialogBox := False;
  Dispose( YN, Done );
  RmWin;
END; { DialogBox }
{------------------------------------------------}

{---------------------------}
{     Database functions    }
{---------------------------}
FUNCTION AddGame: Boolean;
VAR TempS: STRING;
BEGIN
  IF MemAvail < 1000 THEN
  BEGIN
    InfoBox('Insuficient memory. Better save database now!',True);
    AddGame := False;
    Exit;
  END;
  New(GameInfo,Init('New game','No type defined','UNKNOWN',0,0));
  WITH GameInfo^ DO
  BEGIN
    IF DialogBox(' Add game ') THEN
    BEGIN
      Database^.Insert(New(PGameInfo,Init(Name^,Tipe^,FName^,Flags,Size)));
      AddGame := True;
      TempS   := Name^;
      UpdateChange(True);
      Inc(GamesSize,Size);
      IF (Flags AND Cracked) <> 0 THEN Inc(GamesCrack);
      FOR I:=0 TO Database^.Count-1 DO
      BEGIN
        AnEntry := Database^.At(I);
        IF AnEntry^.Name^ = TempS THEN Break;
      END;
      ListSettings^.Position := I+1;
      ListSettings^.MaxTopics:= Database^.Count;
    END ELSE AddGame := False;
  END;
  Dispose(GameInfo,Done);
END; { AddGame }

FUNCTION EditGame(Position:Integer): Boolean;
VAR
  TempS  : STRING;
  Chk    : Boolean;
  OldSize: LongInt;
BEGIN
  AnEntry := Database^.At(Position-1);
  WITH AnEntry^ DO
  BEGIN
    Chk := (Flags AND Cracked) <> 0;
    New(GameInfo,Init(Name^,Tipe^,FName^,Flags,Size));
    Dec(GamesSize,Size);
    IF (Flags AND Selected) <> 0 THEN Dec(SelectSize,Size);
  END;
  WITH GameInfo^ DO
  BEGIN
    IF DialogBox(' Edit game ') THEN
    BEGIN
      Database^.AtFree(Position-1);
      Database^.Insert(New(PGameInfo,Init(Name^,Tipe^,FName^,Flags,Size)));
      EditGame := True;
      TempS    := Name^;
      IF NOT Chk AND ((Flags AND Cracked) <> 0) THEN Inc(GamesCrack);
      IF Chk AND NOT ((Flags AND Cracked) <> 0) THEN Dec(GamesCrack);
      Inc(GamesSize, Size);
      IF (Flags AND Selected) <> 0 THEN
      BEGIN
        IF NOT Chk AND ((Flags AND Cracked) <> 0) THEN Inc( SelectCrack );
        IF Chk AND NOT ((Flags AND Cracked) <> 0) THEN Dec( SelectCrack );
        Inc( SelectSize, Size );
      END;
      UpdateChange( True );
      FOR I:=0 TO Database^.Count-1 DO
      BEGIN
        AnEntry := Database^.At(I);
        IF AnEntry^.Name^ = TempS THEN Break;
      END;
      ListSettings^.Position := I+1;
    END ELSE EditGame := False;
  END;
  Dispose(GameInfo,Done);
END; { EditGame }

PROCEDURE DeleteGame(Position:Integer);
BEGIN
  AnEntry := Database^.At(Position-1);
  WITH AnEntry^ DO
  BEGIN
    Dec(GamesSize, Size);
    IF (Flags AND Cracked) <> 0 THEN Dec(GamesCrack);
    IF (Flags AND Selected)<> 0 THEN
    BEGIN
      Dec(MaxSelect);
      Dec(SelectSize, Size);
      IF (Flags AND Cracked) <> 0 THEN Dec(SelectCrack);
    END;
  END;
  Database^.AtFree(Position-1);
  ListSettings^.MaxTopics := Database^.Count;
  UpdateChange(True);
END; { DeleteGame }

PROCEDURE DeleteSelected;
BEGIN
  I:=0;
  REPEAT
    Inc(I);
    AnEntry := Database^.At(I-1);
    IF (AnEntry^.Flags AND Selected) <> 0 THEN
    BEGIN
      DeleteGame(I);
      Dec(I);
    END;
  UNTIL (MaxSelect=0) OR (I=Database^.Count);
END; { DeleteSelected }
{------------------------------------------------}

PROCEDURE ReSort(Metod: TSortMetod; Asc: Boolean);
VAR Tmp: PGameCollection;
BEGIN
  IF Asc
    THEN ModifyItemParam(4,5,'Ascending')
    ELSE ModifyItemParam(4,5,'Descending');
  Tmp := New(PGameCollection,Init(1,1));
  Tmp^.Duplicates := True;
  Tmp^.SortMetod  := Metod;
  Tmp^.Ascending  := Asc;
  REPEAT
    AnEntry := Database^.At(0);
    WITH AnEntry^ DO New(GameInfo,Init(Name^,Tipe^,FName^,Flags,Size));
    Database^.AtFree(0);
    WITH GameInfo^ DO Tmp^.Insert(New(PGameInfo,Init(Name^,Tipe^,FName^,Flags,Size)));
    Dispose(GameInfo, Done);
  UNTIL Database^.Count = 0;
  Dispose(Database, Done);
  Database := Tmp;
END;

PROCEDURE SortMenu;
VAR R: Byte; Esc: Boolean; YN: PBCollection;
BEGIN
  YN := New( PBCollection, Init(1, 1));
  YN^.Insert( New( PButton, Init('      Name      ', ' ', 5, 4, ButtonFace, ButtonBack, 0, ButtonSelect )));
  YN^.Insert( New( PButton, Init('      Type      ', ' ', 5, 6, ButtonFace, ButtonBack, 0, ButtonSelect )));
  YN^.Insert( New( PButton, Init('      File      ', ' ', 5, 8, ButtonFace, ButtonBack, 0, ButtonSelect )));
  YN^.Insert( New( PButton, Init('      Size      ', ' ', 5, 10, ButtonFace, ButtonBack, 0, ButtonSelect )));
  MkWin(28, 6, 25, 12, White, DialogBack, True, cyrSingle, '');
  Writeln;
  WriteCStr( 26, False, 'Sort database by' );
  WITH YN^ DO
  BEGIN
    Choose(Ord(Database^.SortMetod));
    R   := ButtonNumb;
    Esc := EscPressed;
  END;
  Dispose( YN, Done );
  RmWin;
  IF Esc THEN Exit;
  CASE R+1 OF
    1: BEGIN ReSort(sName, Database^.Ascending); ModifyItemParam(4,4,'Name'); END;
    2: BEGIN ReSort(sType, Database^.Ascending); ModifyItemParam(4,4,'Type'); END;
    3: BEGIN ReSort(sFile, Database^.Ascending); ModifyItemParam(4,4,'File'); END;
    4: BEGIN ReSort(sSize, Database^.Ascending); ModifyItemParam(4,4,'Size'); END;
  END;
  ReDrawList(ListSettings);
END;

PROCEDURE Select(S: Boolean);
BEGIN
  IF (MaxSelect = 0) AND (S = False) THEN Exit;
  IF (MaxSelect = Database^.Count) AND (S = True) THEN Exit;
  FOR I := 0 TO Database^.Count-1 DO
  BEGIN
    AnEntry := Database^.At( I );
    IF S = True
      THEN AnEntry^.Flags := AnEntry^.Flags OR Selected
      ELSE AnEntry^.Flags := AnEntry^.Flags AND NOT Selected;
  END;
  IF S = True
    THEN BEGIN
           MaxSelect := Database^.Count;
           SelectSize := GamesSize;
           SelectCrack := GamesCrack;
         END
    ELSE BEGIN
           MaxSelect := 0;
           SelectSize := 0;
           SelectCrack := 0;
         END;
  ReDrawList(ListSettings);
END;

PROCEDURE InvertSelection;
BEGIN
  FOR I := 0 TO Database^.Count-1 DO
  BEGIN
    AnEntry := Database^.At(I);
    WITH AnEntry^ DO
    BEGIN
      IF (Flags AND Selected) <> 0
        THEN Flags := Flags AND NOT Selected
        ELSE Flags := Flags OR Selected;
      IF (Flags AND Selected) <> 0 THEN
      BEGIN
        Inc( MaxSelect );
        Inc( SelectSize, Size );
        IF (Flags AND Cracked) <> 0 THEN Inc( SelectCrack );
      END ELSE
      BEGIN
        Dec( MaxSelect );
        Dec( SelectSize, Size );
        IF (Flags AND Cracked) <> 0 THEN Dec( SelectCrack );
      END;
    END;
  END;
  ReDrawList(ListSettings);
END;

PROCEDURE Search(Key:Word);
VAR AnEntry: PGameInfo; Yes: Boolean;
BEGIN
  Yes := False;
  IF Key IN [97..122] THEN Dec(Key,32);
  FOR I:=0 TO Database^.Count-1 DO
  BEGIN
    AnEntry := Database^.At(I);
    IF Key = Ord(AnEntry^.Name^[1]) THEN
    BEGIN
      Yes := True;
      Break;
    END;
  END;
  IF (I+1 <> ListSettings^.Position) AND Yes THEN
  BEGIN
    ListSettings^.Position := I+1;
    ReDrawList(ListSettings);
  END;
END;

{$F+}
FUNCTION GetGameName(Position: Integer):STRING;
VAR AnEntry: PGameInfo;
BEGIN
  AnEntry := DataBase^.At(Position-1);
  GetGameName := PadCenter(AnEntry^.Name^,38,' ');
END;

FUNCTION IsGameSelected(Position: Integer):Boolean;
VAR AnEntry: PGameInfo;
BEGIN
  AnEntry := DataBase^.At(Position-1);
  IsGameSelected := False;
  IF (AnEntry^.Flags AND Selected) <> 0 THEN IsGameSelected := True;
END;

PROCEDURE SetGameSelect(Position:Integer; Flag:Boolean);
VAR AnEntry: PGameInfo;
BEGIN
  AnEntry := DataBase^.At(Position-1);
  WITH AnEntry^ DO
  BEGIN
    IF (Flags AND Selected) <> 0
      THEN Flags := Flags AND NOT Selected
      ELSE Flags := Flags OR Selected;
    IF (Flags AND Selected) <> 0 THEN
    BEGIN
      Inc( MaxSelect );
      Inc( SelectSize, Size );
      IF (Flags AND Cracked) <> 0 THEN Inc( SelectCrack );
    END ELSE
    BEGIN
      Dec( MaxSelect );
      Dec( SelectSize, Size );
      IF (Flags AND Cracked) <> 0 THEN Dec( SelectCrack );
    END;
  END;
END;

PROCEDURE UpdateInfoBox(Position:Integer);
VAR
  AnEntry: PGameInfo;
  Empty  : STRING[40];
  TmpStr : STRING[40];

  PROCEDURE WTM( Y: Byte; S: STRING );
  BEGIN
    FastWrite(43,Y,Attr(15,1),Empty);
    FastWrite(43,Y,Attr(15,1),S);
  END;

BEGIN
  IF MaxSelect <> 0
    THEN ModifyItemDisabled(2,6,False)
    ELSE ModifyItemDisabled(2,6,True);
  IF ListSettings^.MaxTopics <> 1
   THEN ModifyItemDisabled(3,3,False)
   ELSE ModifyItemDisabled(3,3,True);
  IF (MaxSelect <> 0) AND (ListSettings^.MaxTopics-MaxSelect >= 1)
   THEN ModifyItemDisabled(3,5,False)
   ELSE ModifyItemDisabled(3,5,True);
  AnEntry := Database^.At(Position-1);
  FillChar(Empty, 38, 0);
  Empty[0] := Chr( 37 );
  WITH AnEntry^ DO
  BEGIN
    WTM(4,Name^);
    WTM(7,Tipe^);
    TmpStr := '';
    IF (Flags AND Cga) <> 0 THEN TmpStr := Concat(TmpStr,'CGA ');
    IF (Flags AND Ega) <> 0 THEN TmpStr := Concat(TmpStr,'EGA ');
    IF (Flags AND Vga) <> 0 THEN TmpStr := Concat(TmpStr,'VGA ');
    WTM(10,TmpStr);
    IF (Flags AND SoundBlaster) <> 0
      THEN TmpStr := 'Sound Blaster or Adlib'
      ELSE TmpStr := 'PC Speaker';
    WTM(13,TmpStr);
    WTM(16,Convert( Size )+' Bytes');
    IF (Flags AND Cracked) <> 0
      THEN TmpStr := 'Yes!'
      ELSE TmpStr := 'No';
    WTM(19,TmpStr);
    WTM(22,FName^);
  END; { With }
END; { UpdateInfoBox }

PROCEDURE SetType(S: STRING);
BEGIN
  AnEntry := Database^.At(ListSettings^.Position-1);
  DisposeStr(AnEntry^.Tipe);
  AnEntry^.tipe := NewStr(S);
  UpdateInfoBox(ListSettings^.Position);
  UpdateChange(True);
END;

PROCEDURE HookListKeys(Position:Integer; VAR Key:Word);
VAR
  AnEntry: PGameInfo;
  Exist: Boolean;
  Masc: Byte;

BEGIN
{  MenuHandle(Key);}
  AnEntry := Database^.At(Position-1);
  Exist   := True;
  Masc    := $00;
  WITH ListSettings^ DO
    CASE Key OF
       33..126: Search(Key);
        kbAlt3: SetType('3D Action');

        kbAltA: SetType('Action');

        kbAltC: SetType('Arcade');

        kbAltD: SetType('Adventure');

        kbAltT: SetType('Sport');

        kbAltS: SetType('Strategy');

        kbAltU: SetType('Simulation');

        kbAltR: SetType('Role-Playing');

        kbAltP: SetType('Platform');

        kbAltL: SetType('Logical');

        kbAltQ: SetType('Simulator');
        kbAltN: SetType('No Type Defined');


          kbF1: Help;
          kbF2: IF PromptBox('Save datafile ?',False) THEN WriteDataFile(True);
          kbF4: IF PromptBox('Write all games to textfile ?',False) THEN WriteTextFile(False);
          kbF5: IF MaxSelect <> 0 THEN
                  IF PromptBox('Write selected games to textfile ?',False) THEN WriteTextFile(True);
          kbF9: ShowStatus;
         kbIns: IF AddGame THEN
                BEGIN
                  IF (MaxTopics-1) < 21 THEN Inc(Lines);
                  ReDrawList(ListSettings);
                END;
         kbTab: IF EditGame(Position) THEN ReDrawList(ListSettings);
         kbDel: IF MaxTopics <> 1 THEN
                  IF PromptBox('Delete game from database ?',True) THEN
                  BEGIN
                    DeleteGame(ListSettings^.Position);
                    ReDrawList(ListSettings);
                  END;
       kbCtrlV: InvertSelection;

       kbCtrlS: Select(True);
       kbCtrlU: Select(False);
       kbCtrlD: IF (MaxSelect <> 0) AND (MaxTopics-MaxSelect >= 1) THEN
                  IF PromptBox('Delete ALL SELECTED games from database ?',True) THEN
                  BEGIN
                    DeleteSelected;
                    ReDrawList(ListSettings);
                  END;
     kbCtrlF10: WriteDescriptionFile;
        kbAltX: IF Changed
                  THEN AlternateExit
                  ELSE EndOfList := True;
         kbEsc: BEGIN
                  Key := 0;
                  IF Changed
                    THEN AlternateExit
                    ELSE IF PromptBox('Quit from GBASE ?',False)
                           THEN EndOfList := True
                END;
  END; { Case }
END; { HookListKeys }

PROCEDURE WatchMenu(Main,Sub: Byte);
BEGIN
  IF (Main = 1) AND (Sub = 1) THEN About;
  IF (Main = 4) AND (Sub = 4) THEN SortMenu;
  IF (Main = 4) AND (Sub = 5) THEN
  BEGIN
    ReSort(Database^.SortMetod, NOT Database^.Ascending);
    ReDrawList(ListSettings);
  END;
END;
{$F-}

PROCEDURE InitMenu;
BEGIN
 NewSubMenu('',15,kbAltSpace);
   NewItem('~About', '', 0);
   NewItem('~Show status','F9',kbF9);

 NewSubMenu('File',24,kbAltF);
   NewItem('~New', '', 0);
   NewItem('~Open...', 'F3', kbF3);
   NewItem('~Save', 'F2', kbF2);
   NewItem('Save ~as...', 'Shift+F2', kbsF2);
   NewItem('Save as ~text', 'F4', kbF4);
   NewItem('Save se~lected as text', 'F5', kbF5);
   NewLine;
   NewItem('E~xit', 'Alt+X', kbAltX);

 NewSubMenu('Edit',22,kbAltE);
   NewItem('~New game', 'Ins', kbIns);
   NewItem('~Edit game', 'Tab', kbTab);
   NewItem('~Delete game', 'Del', kbDel);
   NewLine;
   NewItem('D~elete selected','Ctrl+D',kbCtrlD);

 NewSubMenu('Catalog',23,kbAltC);
   NewItem('~Select all', 'Ctrl+S',kbCtrlS);
   NewItem('~UnSelect all','Ctrl+U',kbCtrlU);
   NewItem('~Invert selection', 'Ctrl+V', kbCtrlV);
   NewItem('So~rt by...', 'Name', 0);
   NewItem('Sorting ~order','Ascending',0);

   ModifyItemDisabled(2,1,True);
   ModifyItemDisabled(2,2,True);
   ModifyItemDisabled(2,4,True);

   MenuBorder := CyrSingle;
   MenuDispacher := WatchMenu;

   DrawMenuBar;
END;

{Ŀ}
{Initialize desktop, font and collection}
{}
PROCEDURE Initialize;
BEGIN
  Randomize;
  SaveScreen;
  Database := New(PGameCollection, Init(1, 1));
  Database^.Comment   := 'GF''s games catalog';
  Database^.SortMetod := sName;
  Database^.Ascending := True;
  Database^.Duplicates:= True;
  DiskFreeSize := DiskFree( 0 );
  CheckBreak   := False;
  CyrilicKB    := False;
  Changed      := False;
  GamesSize    := 0;  GamesCrack   := 0;
  SelectSize   := 0;  SelectCrack  := 0;
  MaxSelect    := 0;
  VLine        := {''}'';
  RAngle       := {''}'';
  ReadDataFile;
  InitListWindow(ListSettings);
  WITH ListSettings^ DO
  BEGIN
    XPos      := 2;
    YPos      := 3;
    Lines     := 21;
    MaxLines  := Lines;
    BarSize   := 38;
    CanSelect := True;
    MaxTopics := Database^.Count;
    GetString := GetGameName;
    GetSelect := IsGameSelected;
    SetSelect := SetGameSelect;
    CheckKey  := HookListKeys;
    MiscProc  := UpdateInfoBox;
  END;
  LoadFont( Cyrilic );
  Cursor( Off );
  SetBlink( False );
  FastWrite(1, 1,  112, PadCenter('GBASE '+Version, 80,' ') );
  FastWrite(1, 25, 112, ' F1 Help '+PadCenter('GBASE '+Version+' by The GodFather',70,' '));
  FastWrite(1, 25, 116, ' F1' );
  IdleHook := @CyrilicHook;
END; { Initialize }
{------------------------------------------------}

(*PROCEDURE InitGenData;
VAR GenData: THeader; f:file; w:word;
BEGIN
  FillChar(GenData,SizeOf(GenData),0);
  WITH GenData DO
  BEGIN
    Header    := GBaseHeader;
    Comment   := Database^.Comment;
    TempCr    := #10;
    Ascending := Database^.Ascending;
    SortMetod := {Database^.SortMetod;}sfile;
    for w := 0 to 40 do comment[w] := chr( ord(comment[w]) xor key1 xor key2);
  END;
  assign(f,'aaaaa');
  rewrite(f,1);
  blockwrite(f,gendata,sizeof(gendata),w);
  close(f);
END;

PROCEDURE Test;
VAR F,F2,F3: Text; S: STRING;
BEGIN
  Assign(F, 'FILE.DOC');  Reset(F);
  Assign(F2,'FILE2.DOC'); Rewrite(F2);
  Assign(F3,'FILE3.DOC'); Rewrite(F3);
  REPEAT
    Readln(F,S);
    FOR I := 0 TO Database^.Count-1 DO
    BEGIN
      AnEntry := Database^.At(I);
      IF AnEntry^.FName^ = S THEN S := '*' + S;
    END;
    Writeln(F2,S);
  UNTIL Eof(F);
  Close(F);
  Close(F2);
  Assign(F2,'FILE2.DOC'); Reset(F2);
  Assign(F3,'FILE3.DOC'); Rewrite(F3);
  REPEAT
    Readln(F2,S);
    IF S[1] <> '*' THEN Writeln(F3,S);
  UNTIL Eof(f2);
  Close(F2);
  Close(F3);
END;*)

{--------------}
{ Main Program }
{--------------}
BEGIN
  IF EgaVgaSystem THEN
  BEGIN
    DialogBack   := evDialogBack;
    ButtonBack   := evButtonBack;
    ButtonFace   := evButtonFace;
    ButtonSelect := evButtonSelect;
  END ELSE
  BEGIN
    DialogBack   := cDialogBack;
    ButtonBack   := cButtonBack;
    ButtonFace   := cButtonFace;
    ButtonSelect := cButtonSelect;
  END;
  Initialize;
  InitMenu;
  FBox( 1, 2, 40, 24, ListSettings^.Palette[BoxColor], 0, cyrDouble);
  WriteBetween(1,40,2,ListSettings^.Palette[BoxColor], 0, ' Games ');
  FBox(41, 2, 80, 24, White, Blue, cyrDouble );
  WriteBetween( 41, 80, 2, White, Blue, ' Game info ');
  WriteAt(43, 3, Yellow, Blue, 'Name:');
  WriteAt(43, 6, Yellow, Blue, 'Type:');
  WriteAt(43, 9, Yellow, Blue, 'Video:');
  WriteAt(43, 12, Yellow, Blue, 'Sound:');
  WriteAt(43, 15, Yellow, Blue, 'Size:');
  WriteAt(43, 18, Yellow, Blue, 'Cracked:');
  WriteAt(43, 21, Yellow, Blue, 'File:');
  ShowListWindow(ListSettings);
  DoneListWindow(ListSettings);
  DisposeMenu;
  TheEnd;
END.
